<?php
if ( ! class_exists( 'Career_Counseling_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Career_Counseling_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Career_Counseling_Plugin_Activation_WPElemento_Importer {

        private static $career_counseling_instance;
        public $career_counseling_action_count;
        public $career_counseling_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$career_counseling_instance) ) {
            self::$career_counseling_instance = new self();
          }
          return self::$career_counseling_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'career_counseling_recommended_plugins', array($this, 'career_counseling_recommended_elemento_importer_plugins_array') );

            $career_counseling_actions                   = $this->career_counseling_get_recommended_actions();
            $this->career_counseling_action_count        = $career_counseling_actions['count'];
            $this->career_counseling_recommended_actions = $career_counseling_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function career_counseling_recommended_elemento_importer_plugins_array($career_counseling_plugins){
            $career_counseling_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'career-counseling'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'career-counseling'),               
            );
            return $career_counseling_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'career-counseling-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('career-counseling-plugin-activation-script', 'career_counseling_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'career-counseling'),
                    'activating' => esc_html__('Activating', 'career-counseling'),
                    'error' => esc_html__('Error', 'career-counseling'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'career-counseling-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function career_counseling_get_recommended_actions() {

            $career_counseling_act_count  = 0;
            $career_counseling_actions_todo = get_option( 'recommending_actions', array());

            $career_counseling_plugins = $this->career_counseling_get_recommended_plugins();

            if ($career_counseling_plugins) {
                foreach ($career_counseling_plugins as $career_counseling_key => $career_counseling_plugin) {
                    $career_counseling_action = array();
                    if (!isset($career_counseling_plugin['slug'])) {
                        continue;
                    }

                    $career_counseling_action['id']   = 'install_' . $career_counseling_plugin['slug'];
                    $career_counseling_action['desc'] = '';
                    if (isset($career_counseling_plugin['desc'])) {
                        $career_counseling_action['desc'] = $career_counseling_plugin['desc'];
                    }

                    $career_counseling_action['name'] = '';
                    if (isset($career_counseling_plugin['name'])) {
                        $career_counseling_action['title'] = $career_counseling_plugin['name'];
                    }

                    $career_counseling_link_and_is_done  = $this->career_counseling_get_plugin_buttion($career_counseling_plugin['slug'], $career_counseling_plugin['name'], $career_counseling_plugin['function']);
                    $career_counseling_action['link']    = $career_counseling_link_and_is_done['button'];
                    $career_counseling_action['is_done'] = $career_counseling_link_and_is_done['done'];
                    if (!$career_counseling_action['is_done'] && (!isset($career_counseling_actions_todo[$career_counseling_action['id']]) || !$career_counseling_actions_todo[$career_counseling_action['id']])) {
                        $career_counseling_act_count++;
                    }
                    $career_counseling_recommended_actions[] = $career_counseling_action;
                    $career_counseling_actions_todo[]        = array('id' => $career_counseling_action['id'], 'watch' => true);
                }
                return array('count' => $career_counseling_act_count, 'actions' => $career_counseling_recommended_actions);
            }

        }

        public function career_counseling_get_recommended_plugins() {

            $career_counseling_plugins = apply_filters('career_counseling_recommended_plugins', array());
            return $career_counseling_plugins;
        }

        public function career_counseling_get_plugin_buttion($slug, $name, $function) {
                $career_counseling_is_done      = false;
                $career_counseling_button_html  = '';
                $career_counseling_is_installed = $this->is_plugin_installed($slug);
                $career_counseling_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $career_counseling_is_activeted = (class_exists($function)) ? true : false;
                if (!$career_counseling_is_installed) {
                    $career_counseling_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $career_counseling_plugin_install_url = wp_nonce_url($career_counseling_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $career_counseling_button_html        = sprintf('<a class="career-counseling-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($career_counseling_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'career-counseling'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'career-counseling')
                    );
                } elseif ($career_counseling_is_installed && !$career_counseling_is_activeted) {

                    $career_counseling_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($career_counseling_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $career_counseling_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $career_counseling_button_html = sprintf('<a class="career-counseling-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($career_counseling_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'career-counseling'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'career-counseling')
                    );
                } elseif ($career_counseling_is_activeted) {
                    $career_counseling_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'career-counseling'));
                    $career_counseling_is_done     = true;
                }

                return array('done' => $career_counseling_is_done, 'button' => $career_counseling_button_html);
            }
        public function is_plugin_installed($slug) {
            $career_counseling_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $career_counseling_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($career_counseling_installed_plugins[$career_counseling_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $career_counseling_keys = array_keys($this->get_installed_plugins());
            foreach ($career_counseling_keys as $career_counseling_key) {
                if (preg_match('|^' . $slug . '/|', $career_counseling_key)) {
                    return $career_counseling_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Career_Counseling_Plugin_Activation_WPElemento_Importer::get_instance();